#version 440 core

/* Input */
layout(location = 0) in vec3 vertexPosition_modelspace;
layout(location = 1) in vec2 vertexUV;
layout(location = 2) in vec3 vertexNormal_modelspace;

/* Output - Interpolated for each fragment*/
out vec2 UV;
out vec3 position_worldspace;
out vec3 normal_cameraspace;
out vec3 cameraDirection_cameraspace;
out vec3 lightDirection_cameraspace;

/* Constants for whole mesh */
uniform mat4 MVP;
uniform mat4 M;
uniform mat4 V;
const vec3 lightPosition_worldspace = vec3(25, 25, 25);

/* Other variables */
vec3 vertexPosition_cameraspace;
vec3 lightPosition_cameraspace;

void main() {
	UV =							vertexUV;
	gl_Position =					MVP * vec4(vertexPosition_modelspace, 1);
	position_worldspace =			(M * vec4(vertexPosition_modelspace, 1)).xyz;
	vertexPosition_cameraspace =	(V * M * vec4(vertexPosition_modelspace, 1)).xyz;
	cameraDirection_cameraspace =	vec3(0, 0, 0) - vertexPosition_cameraspace;
	lightPosition_cameraspace =		(V * vec4(lightPosition_worldspace, 1)).xyz;
	//lightDirection_cameraspace =	lightPosition_cameraspace + cameraDirection_cameraspace;
	lightDirection_cameraspace =	lightPosition_cameraspace - vertexPosition_cameraspace;
	normal_cameraspace =			(V * M * vec4(vertexNormal_modelspace, 0)).xyz;
}